<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>pam_pkcs11: mapper.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">pam_pkcs11
   &#160;<span id="projectnumber">0.6.11</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',false,false,'search.php','Search');
});
</script>
<div id="main-nav"></div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_29c88563d03148ba4c309ff3e02018c1.html">mappers</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">mapper.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="mapper_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * PAM-PKCS11 mapping modules</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Copyright (C) 2005 Juan Antonio Martinez &lt;jonsito@teleline.es&gt;</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * pam-pkcs11 is copyright (C) 2003-2004 of Mario Strasser &lt;mast@gmx.net&gt;</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * This library is free software; you can redistribute it and/or</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> * modify it under the terms of the GNU Lesser General Public</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> * License as published by the Free Software Foundation; either</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> * version 2.1 of the License, or (at your option) any later version.</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * This library is distributed in the hope that it will be useful,</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * but WITHOUT ANY WARRANTY; without even the implied warranty of</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> * Lesser General Public License for more details.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> * You should have received a copy of the GNU Lesser General Public</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> * License along with this library; if not, write to the Free Software</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> * $Id$</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#ifndef __MAPPER_H_</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#define __MAPPER_H_</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#ifdef HAVE_CONFIG_H</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &lt;config.h&gt;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#include &lt;sys/types.h&gt;</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#include &lt;stdlib.h&gt;</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#include &lt;string.h&gt;</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#include &lt;pwd.h&gt;</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#include &lt;../common/cert_st.h&gt;</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#include &quot;../scconf/scconf.h&quot;</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="structmapper__module__st.html">   40</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="structmapper__module__st.html">mapper_module_st</a> {</div><div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="structmapper__module__st.html#a8f8f80d37794cde9472343e4487ba3eb">   42</a></span>&#160;    <span class="keyword">const</span> <span class="keywordtype">char</span> *<a class="code" href="structmapper__module__st.html#a8f8f80d37794cde9472343e4487ba3eb">name</a>; </div><div class="line"><a name="l00044"></a><span class="lineno"><a class="line" href="structmapper__module__st.html#abba81c977d8901de66b169a60d8481e1">   44</a></span>&#160;    <a class="code" href="struct__scconf__block.html">scconf_block</a> *<a class="code" href="structmapper__module__st.html#abba81c977d8901de66b169a60d8481e1">block</a>;</div><div class="line"><a name="l00046"></a><span class="lineno"><a class="line" href="structmapper__module__st.html#ab133ab6f78d4ef8149644d544f8d902c">   46</a></span>&#160;    <span class="keywordtype">int</span>  <a class="code" href="structmapper__module__st.html#ab133ab6f78d4ef8149644d544f8d902c">dbg_level</a>; </div><div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="structmapper__module__st.html#ae376f130b17d169ee51be68077a89ed0">   48</a></span>&#160;    <span class="keywordtype">void</span> *<a class="code" href="structmapper__module__st.html#ae376f130b17d169ee51be68077a89ed0">context</a>; </div><div class="line"><a name="l00050"></a><span class="lineno"><a class="line" href="structmapper__module__st.html#a0b3f1e248acc903be69f8760740fd129">   50</a></span>&#160;    <span class="keywordtype">char</span> **(*entries)(X509 *x509, <span class="keywordtype">void</span> *<a class="code" href="structmapper__module__st.html#ae376f130b17d169ee51be68077a89ed0">context</a>);</div><div class="line"><a name="l00052"></a><span class="lineno"><a class="line" href="structmapper__module__st.html#a0ef1282e2fd43b4d2545e904d379854d">   52</a></span>&#160;    <span class="keywordtype">char</span> *(*finder)(X509 *x509, <span class="keywordtype">void</span> *<a class="code" href="structmapper__module__st.html#ae376f130b17d169ee51be68077a89ed0">context</a>, <span class="keywordtype">int</span> *match);</div><div class="line"><a name="l00054"></a><span class="lineno"><a class="line" href="structmapper__module__st.html#a504be8b48b4dd29419f14bdef5580470">   54</a></span>&#160;    int (*<a class="code" href="structmapper__module__st.html#a504be8b48b4dd29419f14bdef5580470">matcher</a>)(X509 *x509, <span class="keyword">const</span> <span class="keywordtype">char</span> *login, <span class="keywordtype">void</span> *<a class="code" href="structmapper__module__st.html#ae376f130b17d169ee51be68077a89ed0">context</a>);</div><div class="line"><a name="l00056"></a><span class="lineno"><a class="line" href="structmapper__module__st.html#a4c743e14a0f86067abc0df0ca820b05b">   56</a></span>&#160;    void (*<a class="code" href="structmapper__module__st.html#a4c743e14a0f86067abc0df0ca820b05b">deinit</a>)( <span class="keywordtype">void</span> *<a class="code" href="structmapper__module__st.html#ae376f130b17d169ee51be68077a89ed0">context</a>); </div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;} <a class="code" href="mapper_8h.html#a701fdce8eeaa5a0cadca3d947cb838eb">mapper_module</a>;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div><div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="structmapfile.html">   63</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structmapfile.html">mapfile</a> {</div><div class="line"><a name="l00065"></a><span class="lineno"><a class="line" href="structmapfile.html#a69ec24fb2d0a5f5e532deb9adaab81d6">   65</a></span>&#160;        <span class="keyword">const</span> <span class="keywordtype">char</span> *<a class="code" href="structmapfile.html#a69ec24fb2d0a5f5e532deb9adaab81d6">uri</a>;</div><div class="line"><a name="l00067"></a><span class="lineno"><a class="line" href="structmapfile.html#aff2566f4c366b48d73479bef43ee4d2e">   67</a></span>&#160;        <span class="keywordtype">char</span> *<a class="code" href="structmapfile.html#aff2566f4c366b48d73479bef43ee4d2e">buffer</a>;</div><div class="line"><a name="l00069"></a><span class="lineno"><a class="line" href="structmapfile.html#ae809d5359ac030c60a30a8f0b2294b82">   69</a></span>&#160;        <span class="keywordtype">size_t</span> <a class="code" href="structmapfile.html#ae809d5359ac030c60a30a8f0b2294b82">length</a>;</div><div class="line"><a name="l00071"></a><span class="lineno"><a class="line" href="structmapfile.html#a6c968ee6eb10c4ba386621ba90472862">   71</a></span>&#160;        <span class="keywordtype">char</span> *<a class="code" href="structmapfile.html#a6c968ee6eb10c4ba386621ba90472862">pt</a>;</div><div class="line"><a name="l00073"></a><span class="lineno"><a class="line" href="structmapfile.html#a5892a9181e6a332f84d27aecd41dcd12">   73</a></span>&#160;        <span class="keywordtype">char</span> *<a class="code" href="structmapfile.html#a5892a9181e6a332f84d27aecd41dcd12">key</a>;</div><div class="line"><a name="l00075"></a><span class="lineno"><a class="line" href="structmapfile.html#a4e9aec275e566b978a3ccb4e043d8c61">   75</a></span>&#160;        <span class="keywordtype">char</span> *<a class="code" href="structmapfile.html#a4e9aec275e566b978a3ccb4e043d8c61">value</a>;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;};</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="comment">/* ------------------------------------------------------- */</span></div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<a class="code" href="structmapper__module__st.html">mapper_module</a> * <a class="code" href="mapper_8h.html#abd7e377bfc805aeac08054aa5ece69b9">mapper_module_init</a>(<a class="code" href="struct__scconf__block.html">scconf_block</a> *ctx,<span class="keyword">const</span> <span class="keywordtype">char</span> *mapper_name);</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="comment">/* ------------------------------------------------------- */</span></div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<span class="comment">* mapper.c prototype functions</span></div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;<span class="comment">*/</span></div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;<span class="preprocessor">#ifndef __MAPPER_C_</span></div><div class="line"><a name="l00096"></a><span class="lineno"><a class="line" href="mapper_8h.html#a13bd5c2569e42f48a17ce7d7acd6607b">   96</a></span>&#160;<span class="preprocessor">#define MAPPER_EXTERN extern</span></div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;<span class="preprocessor">#define MAPPER_EXTERN</span></div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;<span class="comment">/* mapfile related functions */</span></div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<a class="code" href="mapper_8h.html#a13bd5c2569e42f48a17ce7d7acd6607b">MAPPER_EXTERN</a> <span class="keyword">struct </span><a class="code" href="structmapfile.html">mapfile</a> *<a class="code" href="mapper_8h.html#aff785dc94718a428e1ef46c35dc2dcfa">set_mapent</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *<a class="code" href="structmapfile.html#a69ec24fb2d0a5f5e532deb9adaab81d6">uri</a>);</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;<a class="code" href="mapper_8h.html#a13bd5c2569e42f48a17ce7d7acd6607b">MAPPER_EXTERN</a> <span class="keywordtype">int</span>    <a class="code" href="mapper_8h.html#a1478d4be0cc248ad061a36339c9b3daf">get_mapent</a>(<span class="keyword">struct</span> <a class="code" href="structmapfile.html">mapfile</a> *mfile);</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;<a class="code" href="mapper_8h.html#a13bd5c2569e42f48a17ce7d7acd6607b">MAPPER_EXTERN</a> <span class="keywordtype">void</span>   <a class="code" href="mapper_8h.html#abab71f0630103ff957b9e5d84a6105c0">end_mapent</a>(<span class="keyword">struct</span> <a class="code" href="structmapfile.html">mapfile</a> *mfile);</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;<a class="code" href="mapper_8h.html#a13bd5c2569e42f48a17ce7d7acd6607b">MAPPER_EXTERN</a> <span class="keywordtype">char</span> *<a class="code" href="mapper_8h.html#a3d5d44cc12d4710ab83cd61ced1e6a2f">mapfile_find</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *file,<span class="keywordtype">char</span> *<a class="code" href="structmapfile.html#a5892a9181e6a332f84d27aecd41dcd12">key</a>,<span class="keywordtype">int</span> ignorecase,<span class="keywordtype">int</span> *match);</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;<a class="code" href="mapper_8h.html#a13bd5c2569e42f48a17ce7d7acd6607b">MAPPER_EXTERN</a> <span class="keywordtype">int</span> <a class="code" href="mapper_8h.html#a589ef6dd1c494a11afb251acec024d85">mapfile_match</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *file,<span class="keywordtype">char</span> *<a class="code" href="structmapfile.html#a5892a9181e6a332f84d27aecd41dcd12">key</a>,<span class="keyword">const</span> <span class="keywordtype">char</span> *<a class="code" href="structmapfile.html#a4e9aec275e566b978a3ccb4e043d8c61">value</a>,<span class="keywordtype">int</span> ignorecase);</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;<span class="comment">/* pwent related functions */</span></div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;<a class="code" href="mapper_8h.html#a13bd5c2569e42f48a17ce7d7acd6607b">MAPPER_EXTERN</a> <span class="keywordtype">char</span> *<a class="code" href="mapper_8h.html#a11277748d021c9212e7460b90e10749c">search_pw_entry</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *item, <span class="keywordtype">int</span> ignorecase);</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;<a class="code" href="mapper_8h.html#a13bd5c2569e42f48a17ce7d7acd6607b">MAPPER_EXTERN</a> <span class="keywordtype">int</span> <a class="code" href="mapper_8h.html#a21892c500d029efa93208fd716de48c3">compare_pw_entry</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *item, <span class="keyword">struct</span> passwd *pw,<span class="keywordtype">int</span> ignorecase);</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;<span class="preprocessor">#undef MAPPER_EXTERN</span></div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;<span class="comment">/* ------------------------------------------------------- */</span></div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;</div><div class="line"><a name="l00174"></a><span class="lineno"><a class="line" href="mapper_8h.html#a791f7f44d4bc2b0fb3db279e4f5a8dc0">  174</a></span>&#160;<span class="preprocessor">#define _DEFAULT_MAPPER_FIND_ENTRIES                                    \</span></div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;<span class="preprocessor">static char ** mapper_find_entries(X509 *x509, void *context) {         \</span></div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;<span class="preprocessor">        return NULL;                                                    \</span></div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;<span class="preprocessor">}</span></div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;</div><div class="line"><a name="l00187"></a><span class="lineno"><a class="line" href="mapper_8h.html#ac77f111c63b7a5a1c75c81e5937da326">  187</a></span>&#160;<span class="preprocessor">#define _DEFAULT_MAPPER_FIND_USER                                       \</span></div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;<span class="preprocessor">static char * mapper_find_user(X509 *x509,void *context,int *match) {           \</span></div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;<span class="preprocessor">        if ( !x509 ) return NULL;                                       \</span></div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;<span class="preprocessor">        *match = 1;                                                     \</span></div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;<span class="preprocessor">        return &quot;nobody&quot;;                                                \</span></div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;<span class="preprocessor">}</span></div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;</div><div class="line"><a name="l00204"></a><span class="lineno"><a class="line" href="mapper_8h.html#ac8058aaca72c3f6db063e5128bf8eab1">  204</a></span>&#160;<span class="preprocessor">#define _DEFAULT_MAPPER_MATCH_USER                                      \</span></div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;<span class="preprocessor">static int mapper_match_user(X509 *x509, const char *login, void *context) { \</span></div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;<span class="preprocessor">        int match = 0;                                                  \</span></div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;<span class="preprocessor">        char *username= mapper_find_user(x509,context,&amp;match);          \</span></div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;<span class="preprocessor">        if (!x509) return -1;                                           \</span></div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;<span class="preprocessor">        if (!login) return -1;                                          \</span></div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;<span class="preprocessor">        if (!username) return 0; </span><span class="comment">/*user not found*/</span><span class="preprocessor">                     \</span></div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;<span class="preprocessor">        if ( ! strcmp(login,username) ) return 1; </span><span class="comment">/* match user */</span><span class="preprocessor">      \</span></div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;<span class="preprocessor">        return 0; </span><span class="comment">/* no match */</span><span class="preprocessor">                                        \</span></div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;<span class="preprocessor">}</span></div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;</div><div class="line"><a name="l00219"></a><span class="lineno"><a class="line" href="mapper_8h.html#afc62f3ec1bd2d9427511f13c525fc610">  219</a></span>&#160;<span class="preprocessor">#define _DEFAULT_MAPPER_END                                             \</span></div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;<span class="preprocessor">static void mapper_module_end(void *context) {                          \</span></div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;<span class="preprocessor">        free(context);                                                  \</span></div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;<span class="preprocessor">        return;                                                         \</span></div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;<span class="preprocessor">}                                                                       \</span></div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;<span class="preprocessor"></span></div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;</div><div class="line"><a name="l00232"></a><span class="lineno"><a class="line" href="mapper_8h.html#adb5e0d438bea160c5f0d35a8cdaf6466">  232</a></span>&#160;<span class="preprocessor">#define _DEFAULT_MAPPER_INIT                                            \</span></div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;<span class="preprocessor">mapper_module* mapper_module_init(scconf_block *blk,const char *name) { \</span></div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;<span class="preprocessor">        mapper_module *pt= malloc(sizeof (mapper_module));              \</span></div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;<span class="preprocessor">        if (!pt) return NULL;                                           \</span></div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;<span class="preprocessor">        pt-&gt;name    = name;                                             \</span></div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;<span class="preprocessor">        pt-&gt;context = NULL;                                             \</span></div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;<span class="preprocessor">        pt-&gt;block   = blk;                                              \</span></div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;<span class="preprocessor">        pt-&gt;dbg_level  = get_debug_level();                             \</span></div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;<span class="preprocessor">        pt-&gt;entries = mapper_find_entries;                              \</span></div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;<span class="preprocessor">        pt-&gt;finder  = mapper_find_user;                                 \</span></div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;<span class="preprocessor">        pt-&gt;matcher = mapper_match_user;                                \</span></div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;<span class="preprocessor">        pt-&gt;deinit  = mapper_module_end;                        \</span></div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;<span class="preprocessor">        return pt;                                                      \</span></div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;<span class="preprocessor">}                                                                       \</span></div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;<span class="preprocessor"></span></div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;<span class="comment">/* end of mapper.h file */</span></div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="structmapfile_html_ae809d5359ac030c60a30a8f0b2294b82"><div class="ttname"><a href="structmapfile.html#ae809d5359ac030c60a30a8f0b2294b82">mapfile::length</a></div><div class="ttdeci">size_t length</div><div class="ttdoc">lenght of buffer </div><div class="ttdef"><b>Definition:</b> <a href="mapper_8h_source.html#l00069">mapper.h:69</a></div></div>
<div class="ttc" id="structmapper__module__st_html_ab133ab6f78d4ef8149644d544f8d902c"><div class="ttname"><a href="structmapper__module__st.html#ab133ab6f78d4ef8149644d544f8d902c">mapper_module_st::dbg_level</a></div><div class="ttdeci">int dbg_level</div><div class="ttdoc">debug level to set before call entry points </div><div class="ttdef"><b>Definition:</b> <a href="mapper_8h_source.html#l00046">mapper.h:46</a></div></div>
<div class="ttc" id="structmapfile_html_a5892a9181e6a332f84d27aecd41dcd12"><div class="ttname"><a href="structmapfile.html#a5892a9181e6a332f84d27aecd41dcd12">mapfile::key</a></div><div class="ttdeci">char * key</div><div class="ttdoc">key entry in current buffer </div><div class="ttdef"><b>Definition:</b> <a href="mapper_8h_source.html#l00073">mapper.h:73</a></div></div>
<div class="ttc" id="mapper_8h_html_abd7e377bfc805aeac08054aa5ece69b9"><div class="ttname"><a href="mapper_8h.html#abd7e377bfc805aeac08054aa5ece69b9">mapper_module_init</a></div><div class="ttdeci">mapper_module * mapper_module_init(scconf_block *ctx, const char *mapper_name)</div><div class="ttdoc">Initialize module and mapper_module_st structure. </div></div>
<div class="ttc" id="structmapfile_html_a6c968ee6eb10c4ba386621ba90472862"><div class="ttname"><a href="structmapfile.html#a6c968ee6eb10c4ba386621ba90472862">mapfile::pt</a></div><div class="ttdeci">char * pt</div><div class="ttdoc">pointer to last readed entry in buffer </div><div class="ttdef"><b>Definition:</b> <a href="mapper_8h_source.html#l00071">mapper.h:71</a></div></div>
<div class="ttc" id="structmapfile_html_a4e9aec275e566b978a3ccb4e043d8c61"><div class="ttname"><a href="structmapfile.html#a4e9aec275e566b978a3ccb4e043d8c61">mapfile::value</a></div><div class="ttdeci">char * value</div><div class="ttdoc">value assigned to key </div><div class="ttdef"><b>Definition:</b> <a href="mapper_8h_source.html#l00075">mapper.h:75</a></div></div>
<div class="ttc" id="mapper_8h_html_a589ef6dd1c494a11afb251acec024d85"><div class="ttname"><a href="mapper_8h.html#a589ef6dd1c494a11afb251acec024d85">mapfile_match</a></div><div class="ttdeci">MAPPER_EXTERN int mapfile_match(const char *file, char *key, const char *value, int ignorecase)</div><div class="ttdoc">Try to match provided key to provided name by mean of a mapfile. </div></div>
<div class="ttc" id="structmapper__module__st_html_ae376f130b17d169ee51be68077a89ed0"><div class="ttname"><a href="structmapper__module__st.html#ae376f130b17d169ee51be68077a89ed0">mapper_module_st::context</a></div><div class="ttdeci">void * context</div><div class="ttdoc">pointer to mapper local data </div><div class="ttdef"><b>Definition:</b> <a href="mapper_8h_source.html#l00048">mapper.h:48</a></div></div>
<div class="ttc" id="structmapfile_html"><div class="ttname"><a href="structmapfile.html">mapfile</a></div><div class="ttdoc">This struct is used in processing map files a map file is a list of &quot;key&quot; &quot; -&gt; &quot; &quot;value&quot; text lines...</div><div class="ttdef"><b>Definition:</b> <a href="mapper_8h_source.html#l00063">mapper.h:63</a></div></div>
<div class="ttc" id="structmapper__module__st_html_abba81c977d8901de66b169a60d8481e1"><div class="ttname"><a href="structmapper__module__st.html#abba81c977d8901de66b169a60d8481e1">mapper_module_st::block</a></div><div class="ttdeci">scconf_block * block</div><div class="ttdoc">mapper configuration block </div><div class="ttdef"><b>Definition:</b> <a href="mapper_8h_source.html#l00044">mapper.h:44</a></div></div>
<div class="ttc" id="structmapfile_html_a69ec24fb2d0a5f5e532deb9adaab81d6"><div class="ttname"><a href="structmapfile.html#a69ec24fb2d0a5f5e532deb9adaab81d6">mapfile::uri</a></div><div class="ttdeci">const char * uri</div><div class="ttdoc">URL of mapfile. </div><div class="ttdef"><b>Definition:</b> <a href="mapper_8h_source.html#l00065">mapper.h:65</a></div></div>
<div class="ttc" id="mapper_8h_html_a21892c500d029efa93208fd716de48c3"><div class="ttname"><a href="mapper_8h.html#a21892c500d029efa93208fd716de48c3">compare_pw_entry</a></div><div class="ttdeci">MAPPER_EXTERN int compare_pw_entry(const char *item, struct passwd *pw, int ignorecase)</div><div class="ttdoc">Test if provided item matches pw_name or pw_gecos of provided password structure. ...</div></div>
<div class="ttc" id="mapper_8h_html_a11277748d021c9212e7460b90e10749c"><div class="ttname"><a href="mapper_8h.html#a11277748d021c9212e7460b90e10749c">search_pw_entry</a></div><div class="ttdeci">MAPPER_EXTERN char * search_pw_entry(const char *item, int ignorecase)</div><div class="ttdoc">find the user login that matches pw_name or pw_gecos with provided item </div></div>
<div class="ttc" id="mapper_8h_html_a3d5d44cc12d4710ab83cd61ced1e6a2f"><div class="ttname"><a href="mapper_8h.html#a3d5d44cc12d4710ab83cd61ced1e6a2f">mapfile_find</a></div><div class="ttdeci">MAPPER_EXTERN char * mapfile_find(const char *file, char *key, int ignorecase, int *match)</div><div class="ttdoc">Try to map &quot;key&quot; to provided mapfile. </div></div>
<div class="ttc" id="structmapper__module__st_html_a4c743e14a0f86067abc0df0ca820b05b"><div class="ttname"><a href="structmapper__module__st.html#a4c743e14a0f86067abc0df0ca820b05b">mapper_module_st::deinit</a></div><div class="ttdeci">void(* deinit)(void *context)</div><div class="ttdoc">module de-initialization </div><div class="ttdef"><b>Definition:</b> <a href="mapper_8h_source.html#l00056">mapper.h:56</a></div></div>
<div class="ttc" id="mapper_8h_html_abab71f0630103ff957b9e5d84a6105c0"><div class="ttname"><a href="mapper_8h.html#abab71f0630103ff957b9e5d84a6105c0">end_mapent</a></div><div class="ttdeci">MAPPER_EXTERN void end_mapent(struct mapfile *mfile)</div><div class="ttdoc">Release a mapentry structure. </div></div>
<div class="ttc" id="structmapper__module__st_html"><div class="ttname"><a href="structmapper__module__st.html">mapper_module_st</a></div><div class="ttdoc">Structure to be filled on mapper module initialization. </div><div class="ttdef"><b>Definition:</b> <a href="mapper_8h_source.html#l00040">mapper.h:40</a></div></div>
<div class="ttc" id="mapper_8h_html_a13bd5c2569e42f48a17ce7d7acd6607b"><div class="ttname"><a href="mapper_8h.html#a13bd5c2569e42f48a17ce7d7acd6607b">MAPPER_EXTERN</a></div><div class="ttdeci">#define MAPPER_EXTERN</div><div class="ttdef"><b>Definition:</b> <a href="mapper_8h_source.html#l00096">mapper.h:96</a></div></div>
<div class="ttc" id="structmapper__module__st_html_a504be8b48b4dd29419f14bdef5580470"><div class="ttname"><a href="structmapper__module__st.html#a504be8b48b4dd29419f14bdef5580470">mapper_module_st::matcher</a></div><div class="ttdeci">int(* matcher)(X509 *x509, const char *login, void *context)</div><div class="ttdoc">cert-to-login matcher </div><div class="ttdef"><b>Definition:</b> <a href="mapper_8h_source.html#l00054">mapper.h:54</a></div></div>
<div class="ttc" id="mapper_8h_html_a701fdce8eeaa5a0cadca3d947cb838eb"><div class="ttname"><a href="mapper_8h.html#a701fdce8eeaa5a0cadca3d947cb838eb">mapper_module</a></div><div class="ttdeci">struct mapper_module_st mapper_module</div><div class="ttdoc">Structure to be filled on mapper module initialization. </div></div>
<div class="ttc" id="mapper_8h_html_a1478d4be0cc248ad061a36339c9b3daf"><div class="ttname"><a href="mapper_8h.html#a1478d4be0cc248ad061a36339c9b3daf">get_mapent</a></div><div class="ttdeci">MAPPER_EXTERN int get_mapent(struct mapfile *mfile)</div><div class="ttdoc">Retrieve next entry of given map file. </div></div>
<div class="ttc" id="mapper_8h_html_aff785dc94718a428e1ef46c35dc2dcfa"><div class="ttname"><a href="mapper_8h.html#aff785dc94718a428e1ef46c35dc2dcfa">set_mapent</a></div><div class="ttdeci">MAPPER_EXTERN struct mapfile * set_mapent(const char *uri)</div><div class="ttdoc">Initialize a mapper entry table. </div></div>
<div class="ttc" id="structmapfile_html_aff2566f4c366b48d73479bef43ee4d2e"><div class="ttname"><a href="structmapfile.html#aff2566f4c366b48d73479bef43ee4d2e">mapfile::buffer</a></div><div class="ttdeci">char * buffer</div><div class="ttdoc">buffer to content of mapfile </div><div class="ttdef"><b>Definition:</b> <a href="mapper_8h_source.html#l00067">mapper.h:67</a></div></div>
<div class="ttc" id="structmapper__module__st_html_a8f8f80d37794cde9472343e4487ba3eb"><div class="ttname"><a href="structmapper__module__st.html#a8f8f80d37794cde9472343e4487ba3eb">mapper_module_st::name</a></div><div class="ttdeci">const char * name</div><div class="ttdoc">mapper name </div><div class="ttdef"><b>Definition:</b> <a href="mapper_8h_source.html#l00042">mapper.h:42</a></div></div>
<div class="ttc" id="struct__scconf__block_html"><div class="ttname"><a href="struct__scconf__block.html">_scconf_block</a></div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00077">scconf.h:77</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed May 22 2019 12:09:34 for pam_pkcs11 by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
